#ifndef DOC_CONTENT_H
#define DOC_CONTENT_H

#include <QDebug>
#include <QWidget>
#include <QGridLayout>
#include <QLabel>
#include <QIcon>
#include <QPushButton>
#include <QTextEdit>
#include <QCoreApplication>
#include "helper_caller/call_thread.h"

#include "polkit-qt-1/polkitqt1-authority.h"
using namespace PolkitQt1;

class DocContent : public QWidget
{
    Q_OBJECT
public:
    explicit DocContent(QWidget *parent = 0);
    ~DocContent();

private:
    QSize         _size;
    QIcon         selinuxLedIcon;
    QPushButton  *selinuxLed;
    QLabel       *selinuxLabel;
    QGridLayout  *docLayout;
    QString       currentSEState;
    CallThread   *callThread;
    QTextEdit    *errorLog;

signals:
    void stateChanged(const QString&);
    void warningShowed();

public slots:
    void setInitContent(QSize);
    void setLightSEIcon(const QString&);
    void setDarkSEIcon(const QString&);
    QString getSELinuxState() const;
    void appendErrorMsg(QString&);

private slots:
    void changeSEState();
    bool actionActivated(const QStringList&);
    void resultReceiver(QStringList);
    void warningShow(QString, QString);

};

#endif // DOC_CONTENT_H
