#ifndef VIRT_SANDBOX_RUN_HELPER_H
#define VIRT_SANDBOX_RUN_HELPER_H

#include <QtDBus/QDBusContext>
#include <QCoreApplication>
#include <QProcess>
#include <QFile>
#include <QMap>

#define SERVICE_DOMAIN QString("pro.russianfedora.virtsandboxrunner")

class VSRHelper : public QCoreApplication, protected QDBusContext
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "pro.russianfedora.virtsandboxrunner")
public:
    explicit VSRHelper(int &argc, char **argv);
    ~VSRHelper();

public Q_SLOTS:
    QStringList start(const QStringList&);
    QStringList stop(const QStringList&);
    QStringList getProcessState(const QStringList&);
    QStringList setAuthType(const QStringList&);
    QStringList getAuthType(const QStringList&);
    QStringList setCurrentSELinuxMode(const QStringList&);
    QStringList getVirtNetList(const QStringList&);
    QStringList createVirtNetFromXML(const QStringList&);
    QStringList defineVirtNetFromXML(const QStringList&);
    QStringList destroyVirtNetwork(const QStringList&);
    QStringList undefineVirtNetwork(const QStringList&);
    QStringList startVirtNetwork(const QStringList&);
    QStringList setAutostartVirtNetwork(const QStringList&);

Q_SIGNALS:
    void helperMessage(QStringList&);

private:
    QMap<QString, QProcess*> *processes;
    int timerId;

private slots:
    QString getCurrentSELinuxMode();
    QStringList selectProcessArgs(const QStringList&);
    QStringList selectProcessEnv(const QStringList&);
    QString getJobName(QStringList&) const;
    bool processIsAvailable(QString&) const;
    void errorMSG();
    void timerEvent(QTimerEvent*);
    QStringList readChildren(QString&);
    QStringList findPotentialChildren(QString&);
};


#endif
