#include "call_thread.h"

CallThread::CallThread(QObject *parent) :
    QThread(parent)
{
}
CallThread::~CallThread()
{
    if (key) stop();
}
void CallThread::run()
{
    key = true;
    QStringList parameters;
    parameters<<args;
    parameters.removeFirst();
    //qDebug()<<args;
    //qDebug()<<parameters<<"params";
    QDBusMessage message;
    message = QDBusMessage::createMethodCall(DOMAIN, "/", DOMAIN, args.first().toLatin1());
    QList<QVariant> argumentList;
    argumentList << qVariantFromValue(parameters);
    message.setArguments(argumentList);
    // notice the systemBus here..
    /* used QDBus::Block call mode for wait reply */
    QDBusMessage reply = QDBusConnection::systemBus().call(message, QDBus::Block, checkTimeout*1000);

    //qDebug()<< QDBusConnection::systemBus().lastError().message()<<"+"<<reply.path()<<reply.interface();
    //foreach (QVariant var, reply.arguments()) {
    //    qDebug()<<var.toString();
    //};
    result.clear();
    //qDebug()<<reply.arguments()<<"reply<<"<<args.first();
    if ( reply.type() != QDBusMessage::ReplyMessage ) result<<QVariant(false).toString()<<"Reply Error";
    if ( reply.arguments().size() ) {
        // connect to message receiver
        bool connected = QDBusConnection::systemBus().connect(DOMAIN,
            "/", QString("%1.%2").arg(DOMAIN).arg("start"), "helperMessage",
            QString("QStringList&"), this, "messageReceiver");
        //qDebug()<<"Helper's Messaging connected:"<<QVariant(connected).toString();
        //
        foreach (QVariant var, reply.arguments()) {
            result<<var.toStringList();
        };
    };
    result.insert(1, args.first());
    //qDebug()<<result<<"emit<<"<<args.first();
    emit resultData(result);
    //qDebug()<<result<<"emited<<"<<args.first();
    while (key) msleep(333);
}
void CallThread::setArgs(QStringList &_args, int timeout)
{
    args.clear();
    args<<_args;
    checkTimeout = timeout;
}
void CallThread::stop()
{
    key = false;
    quit();
}
void CallThread::messageReceiver(QStringList &msg)
{
    emit resultData(msg);
}
