#ifndef HELPER_CALLER_H
#define HELPER_CALLER_H

#include <QDebug>
#include <QObject>
#include <QStringList>
#include <QCoreApplication>
#include <QProcess>
#include "call_thread.h"

#include "polkit-qt-1/polkitqt1-authority.h"
using namespace PolkitQt1;

class HelperCaller : public QObject
{
    Q_OBJECT;
public:
    HelperCaller(QObject *parent);
    ~HelperCaller();

signals:
    void resultData(QStringList&);
    void warning(QString&);

private:
    CallThread *callThread;
    QProcess *process;

public slots:
    bool actionActivated(const QStringList&);
    bool actionActivated(const QStringList&, int);
    void stopThread();

private slots:
    void emitResult(QStringList);
    bool isQEMUcontainer(QStringList);
    bool runQEMUcontainer(QStringList, int);
    void errorQEMU();
    void addMsgToLog(QString, QString);
};

#endif // HELPER_CALLER_H
