#ifndef LISTWIDGET_H
#define LISTWIDGET_H

#include <QDebug>
#include <QTreeView>
#include <QMessageBox>
#include "jobmenu.h"
#include "jobitem_model.h"
#include "progressbar_delegate.h"
#include "settings/settings.h"
#include "element/elemsandbox.h"

#define TO_RUN true
#define TO_STOP false

class JobList : public QTreeView
{
    Q_OBJECT

public:
    JobList(QWidget *parent);
    ~JobList();

    QMap<QString, ElemSandbox*>  *jobSandbox;
    JobItemModel                 *jobItemModel;

signals:
    void clickedItem(QString);
    void removeJob(QString&);
    void messageShowed();
    void showVirtNetControl();
    void warning(QString&);

public slots:
    void editItemAction();
    void addJobItem(const QString&);
    void deleteCurrentJobItem();
    void runJob(QModelIndex&);
    void undockJob(QModelIndex&);
    void stopJob(QModelIndex&);

private :
    SettingsDialog       *sDialog;
    ProgressBarDelegate  *progressBarDlg;

private slots:
    void jobItemClicked(const QPoint&);
    void jobItemDoubleClicked(const QModelIndex&);
    void jobItemUndockAction();
    void jobItemKillAction();
    void jobItemRunAction();
    void createJobSandbox(QModelIndex&);
    void checkJob(QModelIndex&, bool);
    void deleteCancelledCreation();
    void showMessage(QString, QString);
    void sendWarning(QString&);
    void mainWindowUp();
    void showVirtControl();
};

#endif
