#ifndef COMMON_SETTINGS_H
#define COMMON_SETTINGS_H

#include <QCheckBox>
#include <QComboBox>
#include <QLineEdit>
#include <QHBoxLayout>
#include <QFileDialog>
#include <QPushButton>
#include <QSpinBox>
#include <QLabel>

#define TIMEOUT 60

class CommonSet : public QWidget
{
  Q_OBJECT;
public:
    CommonSet(QWidget *parent=0);
    ~CommonSet();
    QCheckBox *autoRun;
    QLineEdit *nameEdit;
    QCheckBox *privileged;
    QCheckBox *shell;
    QCheckBox *verbose;
    QCheckBox *debug;
    QComboBox *sandboxType;
    QLineEdit *appendOption;
    QLineEdit *command;
    QSpinBox  *checkTimeout;

private:
    QVBoxLayout *gridLayout;
    QLabel      *typeLabel;
    QHBoxLayout *typeLayout;
    QWidget     *typeWdg;
    QLabel      *timeoutLabel;
    QHBoxLayout *timeoutLayout;
    QWidget     *timeoutWdg;
    QPushButton *selectFile;
    QWidget     *cmdWidget;
    QHBoxLayout *cmdLayout;

public slots:
    QString get_Job_Name() const;
    void set_Job_Name(QString&);

private slots:
    void initTypeBox();
    void setTypeToolTip(QString);
    void initTimeoutWidget();
    void initCmdWidget();
    void setCommandPath();
};

#endif
