#ifndef DIRECTORY_SETTINGS_H
#define DIRECTORY_SETTINGS_H

#include <QAction>
#include <QLabel>
#include <QCheckBox>
#include <QComboBox>
#include <QLineEdit>
#include <QListWidget>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QPushButton>
#include <QMessageBox>
#include <QFileDialog>
#include <QDebug>

class MountSet : public QWidget
{
    Q_OBJECT
public:
    explicit MountSet(QWidget *parent = 0);
    ~MountSet();
    QCheckBox *useMount;

private:
    QString     description;
    QString     fileName;
    QComboBox   *type;
    QPushButton *comment;
    QLabel      *titleLabel;
    QPushButton *addRule;
    QPushButton *delRule;
    QPushButton *addPath;
    QHBoxLayout *layout1;
    QHBoxLayout *layout2;
    QLineEdit   *bindRule;
    QListWidget *to_mount;
    QVBoxLayout *commonLayout;

signals:

public slots:
    void set_FileName(const QString);
    void setCurrentRule(QString);
    QStringList getCurrentRules() const;
    void setCurrentType(QString);
    QString getCurrentType() const;
    QString get_FileName() const;
    void add_HOST_BIND_DST(QString&);

private slots:
    void changeComment(QString);
    void changeMountState(bool);
    void changeMountRule(const QString&);
    void showDescription();
    void addRuleToList();
    void delRuleFromList();
    void delItem(QListWidgetItem*);
    void addPathToRule();
    void editMountItem(QListWidgetItem*);
};

#endif
