#ifndef INCLUDE_SETTINGS_H
#define INCLUDE_SETTINGS_H

#include <QDebug>
#include <QPushButton>
#include <QCheckBox>
#include <QListWidget>
#include <QLineEdit>
#include <QFileDialog>
#include <QGridLayout>
#include <QMessageBox>
#include <QFile>

class IncludeSet : public QWidget
{
  Q_OBJECT;
public:
    IncludeSet(QWidget *parent=0);
    ~IncludeSet();
    QString fileName;
    QCheckBox *enabled;

signals:
    void destinationAdded(QString&);

private:
    QGridLayout *commonLayout;
    QListWidget *fileList;
    QLineEdit   *editDST;
    QPushButton *setDST;
    QPushButton *addFile;
    QPushButton *addDir;
    QPushButton *delPath;
    bool differentiator;

public slots:
    void set_FileName(const QString);
    QString get_FileName() const;
    void setIncludesList(QString);

private slots:
    void enableFileList(bool);
    void addFilesToList();
    void addDirToList();
    void setSourcePath();
    QStringList get_FilesFromDir(QString&);
    void delPathFromList();
    void delItem(QListWidgetItem*);
    void removeDuplicates();
    QStringList get_Included_Path() const;
    void show_Widgets();
    void editItem(QListWidgetItem*);
};

#endif
