#ifndef KERNEL_SET_H
#define KERNEL_SET_H

#define KERNEL QString("vmlinuz-")

#include <QDebug>
#include <QLabel>
#include <QPushButton>
#include <QComboBox>
#include <QLineEdit>
#include <QFileDialog>
#include <QDir>
#include <QVBoxLayout>
#include "sys/utsname.h"

class KernelSet : public QWidget
{
    Q_OBJECT
public:
    explicit KernelSet(QWidget *parent = 0);
    ~KernelSet();

signals:

private:
    QLabel        *kernels;
    QLabel        *kernelForUse;
    QLineEdit     *currentKernel;
    QComboBox     *kernelList;
    QPushButton   *kernelPath;
    QVBoxLayout   *commonLayout;

public slots:
    void setKernelForUse(const QString);
    QString getKernelForUse() const;

private slots:
    void setList_Of_AvailableStandardKernels();
    void setCustomKernelForUse();
};

#endif // KERNEL_SET_H
