#ifndef NETWORK_SETTINGS_H
#define NETWORK_SETTINGS_H

#include <QWidget>
#include <QCheckBox>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QComboBox>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>
#include <QMessageBox>
#include "virt_network/virtnet_control.h"

#include "polkit-qt-1/polkitqt1-authority.h"
using namespace PolkitQt1;

class NetworkSet : public QWidget
{
    Q_OBJECT
public:
    explicit NetworkSet(QWidget *parent = 0);
    ~NetworkSet();
    QCheckBox *useNetwork;
    
signals:
    void showVirtNetControl();

private:
    QPushButton  *virtControlButton;
    QComboBox    *type;
    QLineEdit    *address;
    QLabel       *comment;
    QLineEdit    *source;
    QLineEdit    *mac_address;
    QLabel       *routeTitle;
    QLineEdit    *route;
    QHBoxLayout  *useNetLayout;
    QHBoxLayout  *specsLayout;
    QVBoxLayout  *commonLayout;
    VirtNetControl  *virtNetControl = NULL;

private slots:
    void changeComment(QString);
    void changeNetworkState(bool);
    void changeAddressLabel(const QString&);

public slots:
    void setCurrentAddress(QString);
    QString getCurrentAddress() const;
    void setCurrentType(QString);
    QString getCurrentType() const;
    void setCurrentSource(QString);
    QString getCurrentSource() const;
    void setCurrentMAC(QString);
    QString getCurrentMAC() const;
    void setCurrentRoute(QString);
    QString getCurrentRoute() const;
    void showVirtControl();
};

#endif // NETWORK_SETTINGS_H
