#ifndef AUTH_DIALOG_H
#define AUTH_DIALOG_H

#include <QDebug>
#include <QMenu>
#include <QAction>
#include <QActionGroup>
#include <QSettings>
#include <QMessageBox>
#include "helper_caller/helper_caller.h"

class AuthMenu : public QMenu
{
    Q_OBJECT
public:
    explicit AuthMenu(QMenu *parent = 0);
    ~AuthMenu();

signals:
    void currentIcon(const QString&);
    void warningShowed();

public slots:
    void initAuthType();
    void setCurrentAuthType();

private:
    QAction         *setYes_Action;
    QAction         *setAuthSelf_Action;
    QAction         *setAuthAdmin_Action;
    QAction         *setAuthSelfKeep_Action;
    QAction         *setAuthAdminKeep_Action;
    QActionGroup    *actionGroup;
    QSettings        settings;
    QString          authType;
    HelperCaller    *helperCaller;

private slots:
    void setCurrentIcon(const QString&);
    void connectToSLOTs();
    void disconnectFromSLOTs();
    void setToolTips();
    void setAuthType(bool);
    void saveAuthType(QStringList&);
};

#endif // AUTH_DIALOG_H
