#ifndef TOOLBAR_H
#define TOOLBAR_H

#include <QToolBar>
#include <QAction>
#include <QMenu>
#include "auth_dialog.h"
#include <QDebug>

class ToolBar : public QToolBar
{
  Q_OBJECT
public:
  ToolBar(QWidget *parent);
  ~ToolBar();

  QAction    *_hideAction;
  QAction    *_createAction;
  QAction    *_editAction;
  QAction    *_deleteAction;
  QAction    *_runAction;
  QAction    *_undockAction;
  QAction    *_stopAction;
  QAction    *_stopAllAction;
  QAction    *_virtNetAction;
  QAction    *_exitAction;

signals:
  void        warningShowed();

private:
  QMenu      *itemControlMenu;
  QAction    *itemControlAction;
  AuthMenu   *startMethodMenu;
  AuthMenu   *stopMethodMenu;
  AuthMenu   *setSELinuxModeMethodMenu;
  AuthMenu   *getNetControlMethodMenu;
  AuthMenu   *setAuthTypeMethodMenu;
  QMenu      *authTypeMenu;
  QAction    *authTypeAction;
  QAction    *start_Action;
  QAction    *stop_Action;
  QAction    *setSELinuxMode_Action;
  QAction    *getNetControl_Action;
  QAction    *setAuthType_Action;

private slots:
  void initActions();
  void addItemControlMenu();
  void addAuthTypeMenu();
  void setMenuIcon(const QString&);
  void mainWindowUp();
  void showHoveredMenu();

public slots:
  Qt::ToolBarArea get_ToolBarArea(int) const;
};
#endif
