#include "doc_update.h"

DocUpdate::DocUpdate(QWidget *parent) :
    QDockWidget(parent)
{
    setWindowTitle("Update VirtNetwork List");
    setFeatures(QDockWidget::NoDockWidgetFeatures);
    setFocusPolicy(Qt::ClickFocus);
    hide();
    timerId = 0;
}
DocUpdate::~DocUpdate()
{
    if ( timerId ) {
        killTimer(timerId);
        timerId = 0;
    };
}
void DocUpdate::focusOutEvent(QFocusEvent *ev)
{
    if ( ev->type()==QEvent::FocusOut ) {
        hide();
    }
}
void DocUpdate::timerEvent(QTimerEvent *ev)
{
    int _timerId = ev->timerId();
    if ( timerId && timerId==_timerId ) {
        hide();
        killTimer(timerId);
        timerId = 0;
    }
}
void DocUpdate::showDoc()
{
    show();
    if ( timerId ) {
        killTimer(timerId);
        timerId = 0;
    };
    timerId = startTimer(15000);
}
