#ifndef DOC_UPDATE_CONTENT_H
#define DOC_UPDATE_CONTENT_H

#include <QWidget>
#include <QLabel>
#include <QPushButton>
#include <QTimerEvent>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QTimer>
#include <QSpinBox>
#include <QIcon>
#include <QMouseEvent>
#include <QTextEdit>
#include <QDebug>

class DocUpdateContent : public QWidget
{
    Q_OBJECT
public:
    explicit DocUpdateContent(QWidget *parent = 0, bool check =false, int val = 3);
    ~DocUpdateContent();

signals:
    void actionActivated(const QStringList&);

private:
    QIcon           activeIcon;
    QIcon           usualIcon;
    QIcon           no_activeIcon;
    QPushButton    *LED = NULL;
    QSpinBox       *interval = NULL;
    QPushButton    *applyInterval = NULL;
    QLabel         *virtNetLabel = NULL;
    int             updateInterval;
    int             lastInterval;
    bool            checkList;
    QTimer         *applyTimer = NULL;
    QHBoxLayout    *updateLayout = NULL;
    QTextEdit      *errorLog;
    QVBoxLayout    *commonLayout;

private slots:
    void timerEvent(QTimerEvent*);
    void editInterval();
    void setNewInterval();
    void editIntervalDown();
    void changeUpdateState(bool);
    void setUsualLEDState();

public slots:
    void setLEDActiveIcon();
    void stopUpdateTimer();
    void startUpdateTimer();
    int  getUpdateTime() const;
    bool getCheckList() const;
    void appendErrorMsg(QString&);

};

#endif // DOC_UPDATE_CONTENT_H
