#ifndef VIRTNET_CONTROL_H
#define VIRTNET_CONTROL_H

#include <QMainWindow>
#include <QCoreApplication>
#include <QGridLayout>
#include <QTreeView>
#include <QMouseEvent>
#include <QDockWidget>
#include <QSettings>
#include <QDebug>
#include "helper_caller/call_thread.h"
#include "virtnet_model.h"
#include "doc_update.h"
#include "doc_update_content.h"
#include "virtnet_toolbar.h"
#include "virtnet_control_menu.h"

#include "polkit-qt-1/polkitqt1-authority.h"
using namespace PolkitQt1;

class VirtNetControl : public QMainWindow
{
    Q_OBJECT
public:
    explicit VirtNetControl(QWidget *parent = 0);
    ~VirtNetControl();

signals:

private:
    QSettings          settings;
    VirtNetModel      *virtNetModel = NULL;
    QTreeView         *virtNetList = NULL;
    CallThread        *callThread = NULL;
    QGridLayout       *commonLayout;
    QWidget           *central;
    DocUpdate         *doc = NULL;
    DocUpdateContent  *docContent = NULL;
    VirtNetToolBar    *toolBar;

public slots:
    void startUpdateTimer();

private slots:
    void initDockWidget();
    void closeEvent(QCloseEvent*);
    bool actionActivated(const QStringList&);
    void resultReceiver(QStringList);
    void warningShow(QString, QString);
    void mouseMoveEvent(QMouseEvent*);

    // TODO: display XML format of network item

    void networkClicked(const QPoint&);
    void networkDoubleClicked(const QModelIndex&);
    void appendNetworkName(const QStringList&);
};

#endif // VIRTNET_CONTROL_H
